<?php 
class WPJCE_CodePage
{
	var $attributes = array();
	var $template_js_external_code = "";
	var $js_remove_external_code_button = "";
	function __construct()
	{
		add_action( 'add_meta_boxes_wpjce_custom_code', array( &$this, 'add_custom_meta_boxes' ) );
		add_action( 'save_post', array( &$this, 'process_meta_boxes_data_on_save' ), 999, 2 );
		add_action( 'current_screen', array(&$this, 'cl_set_global_options_pages') );
	}
	function cl_set_global_options_pages($current_screen) 
	{
	  if(!is_admin())
		  return;
	  
	  //wpjce_var_dump($current_screen->id);
	  
	  $page_ids = array(
		"wpjce_custom_code"
	  );
	  //wcsts_var_dump($current_screen->id);
	  if (in_array($current_screen->id, $page_ids)) 
	  {
		global $wpjce_wpml_helper;
		$wpjce_wpml_helper->switch_to_default_language();
		add_filter('acf/settings/current_language', array(&$this, 'cl_acf_set_language'), 100);
	  }
	}
	function cl_acf_set_language() 
	{
	  return acf_get_setting('default_language');
	}
	//Just used for configuration page
	function process_meta_boxes_data_on_save( $code_id, $code_obj ) 
	{
		global $wpjce_post_model;
		
		/* wpjce_var_dump($_POST['wpjce']); 
		wp_die(); */
		
		//Only is save is made by admin page takes place
		if ( !isset( $_POST['wpjce_admin_action'] ) || !wp_verify_nonce( $_POST['wpjce_admin_action'], 'wpjce_code_edit' ) )
			return;
		if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) 
        return;
		// AJAX? Not used here
		if ( defined( 'DOING_AJAX' ) && DOING_AJAX ) 
				return;
		if($code_obj->post_type != 'wpjce_custom_code' || wpjce_get_value_if_set($_POST, 'wpjce', false) == false)
			return;
		
		$wpjce_post_model->remove_all_attributes($code_id);
		//wpjce_var_dump($_POST);
		foreach($_POST['wpjce'] as $attribute_name => $value)
		{
			//wpjce_var_dump($code_id." ".$attribute_name." ".$value);
			$wpjce_post_model->update_attribute($code_id, $attribute_name, $value);
		}
			
		//wp_die();	
	}
	function add_custom_meta_boxes() 
	{
		global $post, $wpjce_html_helper;
		
		add_meta_box( 'wpjce-js-box', __('JS Code', 'wp-js-css-everywhere'), array( &$wpjce_html_helper, 'render_js_editor_box' ), 'wpjce_custom_code', 'normal');
		add_meta_box( 'wpjce-css-box', __('CSS Code', 'wp-js-css-everywhere'), array( &$wpjce_html_helper, 'render_css_editor_box' ), 'wpjce_custom_code', 'normal');
		add_meta_box( 'wpjce-visibility-box', __('Pages visibility', 'wp-js-css-everywhere'), array( &$wpjce_html_helper, 'render_page_filter_box' ), 'wpjce_custom_code', 'normal');
		add_meta_box( 'wpjce-external-box', __('External code', 'wp-js-css-everywhere'), array( &$wpjce_html_helper, 'render_external_code_box' ), 'wpjce_custom_code', 'normal');
		//add_meta_box( 'wpjce-position-selector-box', __('Position', 'wp-js-css-everywhere'), array( &$wpjce_html_helper, 'render_position_box' ), 'wpjce_custom_code', 'side');
	}
	
	
	
	
	
}
?>