<?php 
class WPJCE_Code
{
	var $attributes = array('code-position-js',
							'code-position-css',
							'js-code',
							'css-code',
							'page-filter',
							'external-code-id');
	var $cache_code_data;
	function __construct()
	{
		add_action( 'init', array(&$this, 'register_custom_post_type'), 0 );
		add_action( 'admin_init',  array( &$this, 'add_custom_capabilities' ));
	}
	function add_custom_capabilities()
	{
		$capabilities = array('edit_wpjce_code', 
							  'edit_wpjce_codes',
							  'publish_wpjce_codes',
							  'read_wpjce_code',
							  'read_private_wpjce_codes',
							  'delete_wpjce_codes',
							  'delete_wpjce_code',
							  'create_wpjce_codes',
							  'edit_others_wpjce_codes');
		/* add capabilites to admin */
		$roles = array('manage_woocommerce', 'administrator');
		
		foreach($roles as $role)
		{
			$admin = get_role($role); //get_role('administrator');
			if(isset($admin))
				foreach($capabilities as $capability)
					$admin->add_cap($capability);
		}
	}
	function register_custom_post_type() 
	{
		global $wpjce_user_model;
	
		$is_autorized_user = $wpjce_user_model->is_the_current_user_allowed_to_access_to_plugin_features();
	
		$labels = array(
			'name'                => __( 'Code', 'wp-js-css-everywhere' ),
			'singular_name'       => __( 'Code', 'wp-js-css-everywhere' ),
			'menu_name'           => __( 'Custom JS & CSS', 'wp-js-css-everywhere' ),
			'name_admin_bar'      => __( 'Custom JS & CSS', 'wp-js-css-everywhere' ),
			'parent_item_colon'   => __( 'Parent Item:', 'wp-js-css-everywhere' ),
			'all_items'           => __( 'All code', 'wp-js-css-everywhere' ),
			'add_new_item'        => __( 'Add code', 'wp-js-css-everywhere' ),
			'add_new'             => __( 'Add code', 'wp-js-css-everywhere' ),
			'new_item'            => __( 'New code', 'wp-js-css-everywhere' ),
			'edit_item'           => __( 'Edit code', 'wp-js-css-everywhere' ),
			'update_item'         => __( 'Update code', 'wp-js-css-everywhere' ),
			'view_item'           => __( 'View code', 'wp-js-css-everywhere' ),
			'search_items'        => __( 'Search code', 'wp-js-css-everywhere' ),
			'not_found'           => __( 'Not found', 'wp-js-css-everywhere' ),
			'not_found_in_trash'  => __( 'Not found in Trash', 'wp-js-css-everywhere' ),
		);
		$args = array(
			'label'               => __( 'Custom JS & CSS!', 'wp-js-css-everywhere' ),
			'description'         => __( 'Custom JS & CSS!', 'wp-js-css-everywhere' ),
			'labels'              => $labels,
			//'menu_icon'           => 'dashicons-media-document',
			//'menu_icon'           => WPJCE_PLUGIN_PATH.'/images/icon.png',
			'menu_icon'           => 'data:image/svg+xml;base64,' . base64_encode('<svg  width="20" height="20" viewBox="0 0 2048 1792" xmlns="http://www.w3.org/2000/svg"><path fill="black" d="M681 1399l-50 50q-10 10-23 10t-23-10l-466-466q-10-10-10-23t10-23l466-466q10-10 23-10t23 10l50 50q10 10 10 23t-10 23l-393 393 393 393q10 10 10 23t-10 23zm591-1067l-373 1291q-4 13-15.5 19.5t-23.5 2.5l-62-17q-13-4-19.5-15.5t-2.5-24.5l373-1291q4-13 15.5-19.5t23.5-2.5l62 17q13 4 19.5 15.5t2.5 24.5zm657 651l-466 466q-10 10-23 10t-23-10l-50-50q-10-10-10-23t10-23l393-393-393-393q-10-10-10-23t10-23l50-50q10-10 23-10t23 10l466 466q10 10 10 23t-10 23z"/></svg>'),
			'supports'            =>  /* false */  array('title' ) ,
			'taxonomies'          => array( /*'category' , 'post_tag' */ ),
			'hierarchical'        => false,
			'public'              => false,
			'show_ui'             => true,                                      //'woocommerce': rendered in WooCommerce menu
			'show_in_menu'        => $is_autorized_user /* current_user_can( 'manage_woocommerce' ) ? true : false */,
			/* 'menu_position'       => wcsts_get_free_menu_position(5), */
			'show_in_admin_bar'   => $is_autorized_user,
			'show_in_nav_menus'   => $is_autorized_user,
			'can_export'          => true,
			'has_archive'         => false,		
			'exclude_from_search' => true,
			'publicly_queryable'  => false,
			//'capability_type'     => array('wpjce_code','wpjce_codes')/* 'shop_order' */  ////review-> shop_order raises error
			/* 'rewrite'             => array( 'slug' => 'wppas_photo' ) */
			/* 'capabilities' => array(
				'edit_post' => 'edit_wpjce_code',
				'edit_posts' => 'edit_wpjce_codes',
				//'edit_others_posts' => 'edit_wpjce_codes',
				'publish_posts' => 'publish_wpjce_codes',
				'read_post' => 'read_wpjce_code',
				'read_private_posts' => 'read_private_wpjce_codes',
				'delete_posts' => 'delete_wpjce_codes',
				'delete_post' => 'delete_wpjce_code',
				'create_posts'       => 'create_wpjce_codes',
				 'edit_others_posts'  => 'edit_others_wpjce_codes', 
			),  */
		);
		register_post_type( 'wpjce_custom_code', $args );
		 /* remove_post_type_support('wpjce_custom_code', 'title' );
		remove_post_type_support( 'wpjce_custom_code', 'editor' ); */
		flush_rewrite_rules();
		
		
	}
	public function get_attribute_names()
	{
		return $this->attributes;
	}
	public function get_global_code_data()
	{
		global $wpjce_post_model;
		if(isset($this->cache_code_data))
			return $this->cache_code_data;
		
		$ids = get_posts(array(
					'post_type'        => 'wpjce_custom_code',
					'posts_per_page'=> -1,
					'post_status'      => 'publish',
					'fields'        => 'ids', // Only get post IDs
				));
				
		$result = array();
		foreach($ids as $id)
			$result[$id] = $specific_post_code_data = $wpjce_post_model->get_code_data($id);
			
		//wpjce_var_dump($result);
		$this->cache_code_data = $result;
		return $result;
	}
	/*public function get_code_data($code_id = false)
	{
		$result = array();
		if($code_id != false)
			foreach($this->attributes as $attribute_name)
			{
				$result[$attribute_name] = $this->get_attribute($code_id, $attribute_name);
				$result[$attribute_name] = wpjce_get_value_if_set($result, $attribute_name, false) == false ? "" : $result[$attribute_name];
			}
		else
			foreach($this->attributes as $attribute_name)
				$result[$attribute_name] = "";
		
		return $result;
	}
	public function remove_all_attributes($code_id)
	{
		foreach($this->attributes as $attribute_name)
			$this->remove_attribute($code_id, $attribute_name);
	}
	public function remove_attribute($code_id, $name)
	{
		 delete_post_meta( $code_id, $name);
	}
	public function update_attribute($code_id, $name, $value, $unique  = true)
	{
		update_post_meta($code_id, $name, $value, $unique);
	}
	public function get_attribute($code_id, $name, $single  = true)
	{
		return get_post_meta($code_id, $name, $single );
	}*/
}
?>