<?php 
class WPJCE_Html
{
	var $post_type_to_skip = array('attachment');
	var $template_js_external_code = "";
	var $js_remove_external_code_button = "";
	var $attributes = "";
	var $already_init = false;
	var $init_vars = false;
	function __construct()
	{
		add_action('wp_ajax_wpjce_add_new_page_filter', array(&$this, 'ajax_render_page_filter'));
		add_action('wp_ajax_wpjce_load_page_selector', array(&$this, 'ajax_render_page_selector'));
		add_action( 'load-post.php', array(&$this, 'init') );
		add_action( 'load-post-new.php', array(&$this, 'init') );
	}
	public function init_vars()
	{
		if($this->init_vars)
			return;
		
		$this->init_vars = true;
		wp_nonce_field( 'wpjce_code_edit', 'wpjce_admin_action' ); 
		
		global $post, $wpjce_post_model;
		/* wpjce_var_dump($post->ID);
		wpjce_var_dump($wpjce_post_model->get_code_data(isset($post) ? $post->ID : false)); */
		$this->attributes = $wpjce_post_model->get_code_data(isset($post) ? $post->ID : false); //$post is always defined
		$this->already_init = true;
	}
	public function init()
	{
		/* if($this->already_init)
			return true; */
		
		/* if(!is_admin())
		  return; */
		$post_id = wpjce_get_value_if_set($_GET, 'post', 0);
	    $page_ids = array("wpjce_custom_code");
		$current_screen = get_current_screen();
		
		
		$this->template_js_external_code = '<div class="wpjce-external-code-container">'.
														'<span class="handle dashicons dashicons-menu"></span>'.
														'<span class="wpjce-code-url-preview wpjce-external-code-url-type-%type%">%url%</span>'.
														'<input type="hidden" class="" name="wpjce[external-code-id][%unique_id%][value]" value=%id%></input>'.
														'<input type="hidden" class="" name="wpjce[external-code-id][%unique_id%][type]" value=%type%></input>'.
														'<input type="hidden" class="" name="wpjce[external-code-id][%unique_id%][is_remote]" value="false"></input>'.
														'<select class="wpjce-external-code-position-selector" name="wpjce[external-code-id][%unique_id%][position]">'.
															'<option value="header" %header_is_selected%>'.__( 'Header', 'wp-js-css-everywhere' ).'</option>'.
															'<option value="footer" %footer_is_selected%>'.__( 'Footer', 'wp-js-css-everywhere' ).'</option>'.
														'</select>'.
														'<select class="wpjce-external-code-position-selector" name="wpjce[external-code-id][%unique_id%][enabled]">'.
															'<option value="yes" %code_is_enabled%>'.__( 'Enabled', 'wp-js-css-everywhere' ).'</option>'.
															'<option value="no" %code_is_disabled%>'.__( 'Disabled', 'wp-js-css-everywhere' ).'</option>'.
														'</select>'.
														'<button class="button wpjce-code-container-remove-button wpjce_remove_button">%remove_button_text%</button>'.
													 '</div>';
		$this->template_js_external_code_remote_link = '<div class="wpjce-external-code-container">'.
															'<span class="handle dashicons dashicons-menu"></span>'.
															'<span class="wpjce-code-url-preview wpjce-external-code-url-type-%type%">%url%</span>'.
															'<input type="hidden" class="" name="wpjce[external-code-id][%unique_id%][value]" value=%value%></input>'.
															'<input type="hidden" class="" name="wpjce[external-code-id][%unique_id%][type]" value=%type%></input>'.
															'<input type="hidden" class="" name="wpjce[external-code-id][%unique_id%][is_remote]" value="true"></input>'.
															'<select class="wpjce-external-code-position-selector" name="wpjce[external-code-id][%unique_id%][position]">'.
																'<option value="header" %header_is_selected%>'.__( 'Header', 'wp-js-css-everywhere' ).'</option>'.
																'<option value="footer" %footer_is_selected%>'.__( 'Footer', 'wp-js-css-everywhere' ).'</option>'.
															'</select>'.
															'<select class="wpjce-external-code-position-selector" name="wpjce[external-code-id][%unique_id%][enabled]">'.
																'<option value="yes" %code_is_enabled%>'.__( 'Enabled', 'wp-js-css-everywhere' ).'</option>'.
																'<option value="no" %code_is_disabled%>'.__( 'Disabled', 'wp-js-css-everywhere' ).'</option>'.
															'</select>'.
															'<button class="button wpjce-code-container-remove-button wpjce_remove_button">%remove_button_text%</button>'.
														 '</div>';
		$this->js_remove_external_code_button = __( 'Remove', 'wp-js-css-everywhere' );
		
		//CSS
		/* wp_enqueue_style('wpjce-codemirror-css-file', WPJCE_PLUGIN_PATH. '/css/vendor/codemirror/codemirror.css' );
		wp_enqueue_style('wpjce-codemirror-hint', WPJCE_PLUGIN_PATH. '/css/vendor/codemirror/codemirror/addon/show-hint.css' ); */
		wp_enqueue_style('wpjce-select2', WPJCE_PLUGIN_PATH. '/css/vendor/select2/select2.min.css' );
		wp_enqueue_style('wpjce-admin-code-page-css', WPJCE_PLUGIN_PATH. '/css/admin-code-page.css' );
		if($this->is_gutenberg_active())
			wp_enqueue_style('wpjce-gutenberg-css', WPJCE_PLUGIN_PATH. '/css/admin-gutenberg.css' );
		
		//JS
		if($post_id != 0 && get_post_type($post_id)=='wpjce_custom_code')
			wp_enqueue_media(); //in pages different by the custom post page it causes the "feature image" to not work
								//its include is forced because it happens that some themes/plugins prevent media js library to be included
							
		//wp_enqueue_script('selectWoo');
		/* wp_enqueue_script('wpjce-codemirror', WPJCE_PLUGIN_PATH. '/js/vendor/codemirror/codemirror.js', array('jquery') );		
		//wp_enqueue_script('wpjce-codemirror-css-helper', WPJCE_PLUGIN_PATH. '/js/codemirror-css-helper.js', array('jquery') );
		wp_enqueue_script('wpjce-codemirror-css', WPJCE_PLUGIN_PATH. '/js/vendor/codemirror/mode/css/css.js', array('jquery') );
		wp_enqueue_script('wpjce-codemirror-js', WPJCE_PLUGIN_PATH. '/js/vendor/codemirror/mode/javascript/javascript.js', array('jquery') );
		wp_enqueue_script('wpjce-codemirror-javascript-hint', WPJCE_PLUGIN_PATH. '/js/vendor/codemirror/addon/hint/javascript-hint.js', array('jquery') );
		wp_enqueue_script('wpjce-codemirror-css-hint', WPJCE_PLUGIN_PATH. '/js/vendor/codemirror/addon/hint/css-hint.js', array('jquery') );
		wp_enqueue_script('wpjce-codemirror-show-hint', WPJCE_PLUGIN_PATH. '/js/vendor/codemirror/addon/hint/show-hint.js', array('jquery') ); */
		wp_enqueue_script('select2', WPJCE_PLUGIN_PATH. '/js/vendor/select2/select2.full.js', array('jquery') );
		wp_enqueue_script('jquery-ui-sortable');
		wp_enqueue_script('wpjce-ace', WPJCE_PLUGIN_PATH. '/js/vendor/ace/src-min-noconflict/ace.js', array('jquery') ); 
		wp_register_script('wpjce-admin-code-page', WPJCE_PLUGIN_PATH. '/js/admin-code-page.js', array('jquery') );
		wp_enqueue_script('wpjce-admin-code-page-type-filter-manager', WPJCE_PLUGIN_PATH. '/js/admin-code-page-type-filter-manager.js', array('jquery') );
		wp_enqueue_script('wpjce-admin-code-page-load-post-by-type', WPJCE_PLUGIN_PATH. '/js/admin-code-page-load-post-by-type.js', array('jquery') );
		wp_register_script('wpjce-admin-code-page-attachement-loader', WPJCE_PLUGIN_PATH. '/js/admin-code-page-attachement-loader.js', array('jquery') );
		$js_options = array(
				'remove_button_text' => $this->js_remove_external_code_button,
				'template_js_external_code' => $this->template_js_external_code,
				'template_js_external_code_remote_link' => $this->template_js_external_code_remote_link,
				'enter_url_text' => __('Enter the URL', 'wp-js-css-everywhere'),
				'url_type_error' => __('The URL must end with .js or .css!', 'wp-js-css-everywhere'),
				'is_gutenberg_active' => $this->is_gutenberg_active() ? 'true' : 'false'
			);
		wp_localize_script( 'wpjce-admin-code-page-attachement-loader', 'wpjce', $js_options );
		wp_localize_script( 'wpjce-admin-code-page', 'wpjce', $js_options );
		wp_enqueue_script('wpjce-admin-code-page-attachement-loader');
		wp_enqueue_script('wpjce-admin-code-page');
		
		//wpjce_var_dump($this->already_init);
		
	}
	private function is_gutenberg_active() 
	{
		/* $gutenberg    = false;
		$block_editor = false;

		if ( has_filter( 'replace_editor', 'gutenberg_init' ) ) {
			// Gutenberg is installed and activated.
			$gutenberg = true;
		}

		if ( version_compare( $GLOBALS['wp_version'], '5.0-beta', '>' ) ) {
			// Block editor.
			$block_editor = true;
		}

		if ( ! $gutenberg && ! $block_editor ) {
			return false;
		}

		include_once ABSPATH . 'wp-admin/includes/plugin.php';

		if ( ! is_plugin_active( 'classic-editor/classic-editor.php' ) ) {
			return true;
		}

		$use_block_editor = ( get_option( 'classic-editor-replace' ) === 'no-replace' );

		return $use_block_editor; */
		if ( function_exists( 'is_gutenberg_page' ) &&
            is_gutenberg_page()
		) {
			// The Gutenberg plugin is on.
			return true;
		}
		$current_screen = get_current_screen();
		if ( method_exists( $current_screen, 'is_block_editor' ) &&
				$current_screen->is_block_editor()
		) {
			// Gutenberg page on 5+.
			return true;
		}
		return false;
	}
	function ajax_render_page_filter()
	{
		$this->render_page_type_filter();
		wp_die();
	}
	function ajax_render_page_selector()
	{
		$this->render_page_selector($_POST['page_type']);
		wp_die();
	}
	/* HTML */
	function render_js_editor_box()
	{
		 $this->init_vars();
		
		
		?>
		<textarea id="wpjce-js-code"><?php echo $this->attributes['js-code']; ?></textarea>
		<textarea id="wpjce-js-code-hidden" style="display:none;" name="wpjce[js-code]"><?php echo $this->attributes['js-code']; ?></textarea>
		<?php 
		
		$this->render_position_box("js");
	}
	function render_css_editor_box()
	{
		 $this->init_vars();
		
		?>
		<textarea id="wpjce-css-code" ><?php echo $this->attributes['css-code']; ?></textarea>
		<textarea id="wpjce-css-code-hidden" style="display:none;" name="wpjce[css-code]"><?php echo $this->attributes['css-code']; ?></textarea>
		<?php 
		$this->render_position_box("css");
	}
	function render_position_box($type = "css")
	{
		 $this->init_vars();
		
		?>
		<p>
			<?php _e('Select in which page position the code has to be rendered: ', 'wp-js-css-everywhere'); ?>
		</p>
		<div class="wpjec-position-selector-container">
			<input checked="checked" value="header" name="wpjce[code-position-<?php echo $type; ?>]"   type="radio" <?php checked($this->attributes['code-position-'.$type], 'header', true); ?>>
			<label class="dashicons-before dashicons-arrow-up-alt2"><?php _e('Header', 'wp-js-css-everywhere'); ?></label><br>
			<input value="footer" name="wpjce[code-position-<?php echo $type; ?>]" type="radio" <?php checked($this->attributes['code-position-'.$type], 'footer', true); ?> >
			<label class="dashicons-before dashicons-arrow-down-alt2"><?php _e('Footer', 'wp-js-css-everywhere'); ?></label><br>
		</div>
		<?php 
	}
	function render_page_filter_box()
	{
		 $this->init_vars();
		
		?>
		<p>
		<?php _e('By default the code is included in every page. To include only in a specific set of pages, select in which ones it has to be included:', 'wp-js-css-everywhere'); ?>
		</p>
		<div id="wpjce-page-filters-container">
			<?php 
					if(is_array($this->attributes['page-filter']))
						foreach($this->attributes['page-filter'] as $page_data)
									$this->render_page_type_filter($page_data);
				?>
		</div>
		<div  id="wpce-add-new-page-filter-action-container">
			<button class="button button-primary" id="wpce-add-new-page-filter-button"><?php _e('Add', 'wp-js-css-everywhere'); ?></button>
			<span class="spinner" id="wpce-add-new-page-filter-spinner"></span>
		</div>
		<?php 
	}
	function render_external_code_box()
	{
		global $wpjce_post_model;
		 $this->init_vars();
		 //wpjce_var_dump($this->attributes);
		?>
		<p>
		<?php _e('You can optionally include external files', 'wp-js-css-everywhere'); ?>
		</p>
		<div id="wpjce-external-files-container" class="wpjec-sortable">
			<?php 
					if(is_array($this->attributes['external-code-id']))
						foreach($this->attributes['external-code-id'] as $unique_id => $external_code_id)
						{
							if(wpjce_get_value_if_set($external_code_id, 'value', false) == false)
								continue;
							
							$external_code_id['enabled'] = wpjce_get_value_if_set($external_code_id, 'enabled', 'yes');
							
							//wpjce_var_dump($external_code_id);
							$is_remote = isset($external_code_id['is_remote']) && $external_code_id['is_remote'] == 'true';
							$url =  $is_remote ? $external_code_id['value'] : $wpjce_post_model->get_attachment_url($external_code_id['value']) ; 
							$template = $is_remote ? $this->template_js_external_code_remote_link : $this->template_js_external_code;
							$position = $external_code_id['position'];
							
							$template = str_replace("%type%", wpjce_get_file_type_by_url($url), $template);
							$template = str_replace("%url%", trim($url), $template);
							$template = str_replace("%id%", $external_code_id['value'], $template);
							$template = str_replace("%unique_id%", $unique_id, $template);
							if($is_remote)
								$template = str_replace("%value%", $url, $template);
							$template = str_replace("%remove_button_text%", $this->js_remove_external_code_button, $template);
							$template = str_replace("%header_is_selected%", $external_code_id['position'] == 'header' ? ' selected="selected" ' : "" , $template);
							$template = str_replace("%footer_is_selected%", $external_code_id['position'] == 'footer' ? ' selected="selected" ' : "" , $template);
							$template = str_replace("%code_is_enabled%", $external_code_id['enabled'] == 'yes' ? ' selected="selected" ' : "" , $template);
							$template = str_replace("%code_is_disabled%", $external_code_id['enabled'] == 'no' ? ' selected="selected" ' : "" , $template);
							
							echo $template;
						}
				?>
		</div>
		<div  id="wpce-add-new-page-filter-action-container">
			<button class="button button-primary wpjce-load-script-file-button" id="wpce-add-external-file-button"><?php _e('Load CSS/JS file', 'wp-js-css-everywhere'); ?></button>
			<button class="button button-primary wpjce-load-script-file-button" id="wpce-add-remote-file-button"><?php _e('Link remote CSS/JS file', 'wp-js-css-everywhere'); ?></button>
			<!-- <span class="spinner" id="wpce-add-new-page-filter-spinner"></span>-->
		</div>
		<?php 
	}
	//used also for ajax
	function render_page_type_filter($page_data = false)
	{
		$selected = $page_data  != false  ? $page_data['type'] : "url";
		$id = rand(0, 999999);
		?>
		<div class="wpjce-page-filter-single-container">
			<select class="wpjce-page-type-selector" data-id="<?php echo $id; ?>">
				<option value="url"><?php _e('Specific URL', 'woocommerce-support-ticket-system'); ?></option>
				<!--<option value="custom_post"><?php _e('Custom post', 'woocommerce-support-ticket-system'); ?></option>-->
				<?php foreach(get_post_types(array('public' => true), 'objects') as $custom_post): 
					if(in_array($custom_post->name, $this->post_type_to_skip))
						continue; ?>
					<option value="<?php echo $custom_post->name; ?>" <?php selected( $selected, $custom_post->name)?> ><?php echo $custom_post->label; ?></option>
				<?php endforeach; ?>
			</select>
			<div id="wpjce-page-filter-result-<?php echo $id; ?>" class="wpjce-page-filter-result">
				<?php 
						$this->render_page_selector($selected, $page_data);
				?>
			</div>
		</div>
		<?php
	}
	//used also for ajax
	function render_page_selector($type = "url" , $page_data = false)
	{
		global $wpjce_post_model;
		$id = rand(0, 999999);
		$selected = $page_data  != false  ? $page_data['restriction'] : "";
		$value = $page_data != false ?  $page_data['value'] : "";
		if($type == 'url')
		{
			?>
			<input type="hidden" name="wpjce[page-filter][<?php echo $id; ?>][type]" value="url"></input>
			<select name="wpjce[page-filter][<?php echo $id; ?>][restriction]"> 
				<option value="starts_with" <?php selected( $selected, 'starts_with'); ?>><?php _e('Starts with', 'woocommerce-support-ticket-system'); ?></option>
				<option value="ends_with" <?php selected( $selected, 'ends_with'); ?>><?php _e('Ends with', 'woocommerce-support-ticket-system'); ?></option>
				<option value="equal_to" <?php selected( $selected, 'equal_to'); ?>><?php _e('Is equal to', 'woocommerce-support-ticket-system'); ?></option>
				<option value="not_equal_to" <?php selected( $selected, 'not_equal_to'); ?>><?php _e('Is not equal to', 'woocommerce-support-ticket-system'); ?></option>
				<option value="contains" <?php selected( $selected, 'contains'); ?>><?php _e('Contains', 'woocommerce-support-ticket-system'); ?></option>
				<option value="not_contains" <?php selected( $selected, 'not_contains'); ?>><?php _e('Not contains', 'woocommerce-support-ticket-system'); ?></option>
			</select>
			<input type="text" value="<?php echo $value;?> " name="wpjce[page-filter][<?php echo $id; ?>][value]" required="required" class="wpjce_input" placeholder="http://www.yoursite.com/shop"></input> <span class="wpjce_required">*</span>
			<button class="button wpjce_page_filter_remove_button wpjce_remove_button"><?php _e('Remove', 'woocommerce-support-ticket-system'); ?></button>
			<?php 
		}
		else
		{
			?>
			<input type="hidden" name="wpjce[page-filter][<?php echo $id; ?>][type]" value="<?php echo $type; ?>"></input>
			<select name="wpjce[page-filter][<?php echo $id; ?>][restriction]"> 
				<option value="belongs" <?php selected( $selected, 'belongs'); ?>><?php _e('Belongs', 'woocommerce-support-ticket-system'); ?></option>
				<option value="not_belongs" <?php selected( $selected, 'not_belongs'); ?>><?php _e('Not belongs', 'woocommerce-support-ticket-system'); ?></option>
			</select>
			<select class="wpjce-post-selector-ajax" 
						name="wpjce[page-filter][<?php echo $id; ?>][value][]" 
						multiple="multiple" 
						required="required"
						data-type="<?php echo $type; ?>">
						<?php 
						 foreach( $value as $post_id)
							{
								echo '<option value="'.$post_id.'" selected="selected" >'.$wpjce_post_model->get_post_title($post_id).'</option>';
							}  
						?>
			</select>
			<span class="wpjce_required">*</span>
			<button class="button wpjce_remove_button wpjce_page_filter_remove_button"><?php _e('Remove', 'woocommerce-support-ticket-system'); ?></button>
			
			<?php 
		}
	}
}
?>