<?php 
class WPJCE_Post
{
	var $attributes;
	var $cache_code_data = array();
	function __construct()
	{
		add_action('wp_ajax_wpjce_load_posts', array(&$this, 'ajax_load_posts'));
		add_action('init', array(&$this, 'init'));
	}
	function init()
	{
		global $wpjce_code_model;
		$this->attributes = $wpjce_code_model->get_attribute_names();
	}
	function ajax_load_posts()
	{
		$resultCount = 50;
		$search_string = isset($_GET['search_string']) ? $_GET['search_string'] : null;
		$post_type = isset($_GET['post_type']) ? $_GET['post_type'] : 'post';
		$page = isset($_GET['page']) ? $_GET['page'] : null;
		$offset = isset($page) ? ($page - 1) * $resultCount : null;
		$product_list = $this->get_post_list($search_string, $post_type, $offset, $resultCount);
		echo json_encode( $product_list); 
		wp_die();
	}
	function get_post_list($search_string, $post_type, $offset, $resultCount)
	{
		global $wpdb, $wpjce_wpml_helper;
		$product_or_condition = $post_type == 'product' ? " OR post.post_type = 'product_variation' ": "";
		 $query_string = "SELECT post.ID as id, post.post_parent as post_parent, post.post_title as post_title ".//, product_meta.meta_value as product_sku
							" FROM {$wpdb->posts} AS post ".
							// "LEFT JOIN {$wpdb->postmeta} AS product_meta ON product_meta.post_id = post.ID AND product_meta.meta_key = '_sku'".
							" WHERE  post_status IN ('".implode("','",$this->get_statuses_for_query())."') AND (post.post_type = '{$post_type}' {$product_or_condition})
							";
		if($search_string)
				$query_string .=  " AND ( post.post_title LIKE '%{$search_string}%' OR product_meta.meta_value LIKE '%{$search_string}%' OR post.ID LIKE '%{$search_string}%' ) 
								   AND (post.post_type = '{$post_type}' {$product_or_condition}) ";
		
		$query_string .=  " GROUP BY post.ID ";
		
		$result = $wpdb->get_results($query_string ) ;
		
		if($wpjce_wpml_helper->wpml_is_active())
		{
			$product_ids = $variation_ids = array();
			foreach($result as $product)
			{
				if($product->product_parent == 0 )
					$product_ids[] = $product;
				else
					$variation_ids[] = $product;
			}
			//$result = $wpjce_wpml_helper->remove_translated_id($result, 'product', true);
			
			//Filter products
			if(!empty($product_ids))
				$product_ids = $wpjce_wpml_helper->remove_translated_id($product_ids, $post_type, true);
			
			//Filter variations
			if(!empty($variation_ids))
				$variation_ids = $wpjce_wpml_helper->remove_translated_id($variation_ids, $post_type, true);
			
			$result = array_merge($product_ids, $variation_ids);
		}
		
		//wpjce_var_dump($result);
		if(isset($result) && !empty($result))
			foreach($result as $index => $obj)
				{
					if($post_type != 'product' || !function_exists('wc_get_product'))
						continue;
					
					$wc_product = wc_get_product($obj->id);
					//if(is_a($obj, 'WC_Product_Variation') && $obj->product_parent != 0 )
					if(isset($wc_product) && $wc_product != false && $wc_product->get_type() == 'variation')
					{
						//wpjce_var_dump($obj->get_type());
						//if(!isset($wc_product) || $wc_product == false)
						{
							//wpjce_var_dump("No: ".$obj->id);
							//unset($result[$index]);
						}
						//else if($wc_product->get_type() == 'variation')
						{
							//wpjce_var_dump("Ok: ".$obj->id);
							$readable_name = $this->get_variation_complete_name($obj->id);
							//wpjce_var_dump("name: ".$readable_name);
							$result[$index]->post_title = $readable_name != false ? "<i>".__('Variation','woocommerce-files-upload')."</i> ".$readable_name : $result[$index]->post_title;
						}
					}
				}
		
		
		if(isset($offset) && isset($resultCount))
		{
			/* $query_string = "SELECT COUNT(*) as tot
							 FROM {$wpdb->products} AS products
							  "; */
			$num_order = $wpdb->get_col($query_string);
			$num_order = isset($num_order[0]) ? $num_order[0] : 0;
			$endCount = $offset + $resultCount;
			$morePages = $num_order > $endCount;
			$results = array(
				  "results" => $result,
				  "pagination" => array(
					  "more" => $morePages
				  )
			  );
		}
		else
			$results = array(
				  "results" => $result,
				  "pagination" => array(
					  "more" => false
				  )
			  );
		//wpjce_var_dump($results);
		return $results;
	}
	public function get_post_title($post_id)
	{
		global $wpjce_wpml_helper;
		$post_data = get_post($post_id);
		//WPML
		$translated_post_id = $wpjce_wpml_helper->get_main_language_id($post_id, $post_data->post_type);
		$post_data = $translated_post_id != $post_id ? get_post($translated_post_id) : $post_data;
		
		
		$prefix = "ID: ".$translated_post_id." - ";
		$readable_name = $prefix.$post_data->post_title;
		if( function_exists('wc_get_product') && ($post_data->post_type == 'product' || $post_data->post_type == 'product_variation'))
		{
			$product_id = $post_id;
			$default = false;
			$readable_name  = $default;
			$product = wc_get_product($product_id);
			
			if($product->get_type() == 'variation')
			{
				$readable_name = $this->get_variation_complete_name($product_id);
				$readable_name = isset($readable_name) && $readable_name != "" && $readable_name != " " ? $prefix.$readable_name  : $default;
			}
			else
			{
				try{
					//$readable_name = isset($product) ? $product->get_formatted_name() : $default;
					$readable_name = isset($product) && $product != false ?  $prefix.$product->get_name() : $default;
				}catch (Exception $e){}
			}
		}
		
		return $readable_name; 
	}
	public function get_variation_complete_name($variation_id)
	 {
		 if(!function_exists('wc_get_product'))
		 {
			$post_data = get_post($post_id);
			return $post_data->post_title;
		 }
		$error = false;
		$variation = wc_get_product($variation_id);
		//wcqpe_var_dump("inside ".$variation->get_type());
		if($variation == null || $variation == false)
			return "";
		if($variation->is_type('simple') || $variation->is_type('variable'))
			return $variation->get_title();
		
		$product_name = $variation->get_title()." - ";	
		if($product_name == " - ")
			return false;
		$attributes_counter = 0;
		foreach($variation->get_variation_attributes( ) as $attribute_name => $value)
		{
			
			if($attributes_counter > 0)
				$product_name .= ", ";
			$meta_key = urldecode( str_replace( 'attribute_', '', $attribute_name ) ); 
			//wcqpe_var_dump($value);
			$product_name .= " ".wc_attribute_label($meta_key).": ".$value;
			$attributes_counter++;
		}
		return $product_name;
	 }
	 
	public function get_attachment_url($external_post_id)
	{
		return wp_get_attachment_url($external_post_id);
	}
	public function get_attachment_path($external_post_id)
	{
		return get_attached_file($external_post_id);
	}
	public function url_matches_filter($url, $filter_data)
	{
		global $post;
		$result = true;
		foreach((array)$filter_data as $data)
		{
			if($data['type'] == 'url')
			{
				$value = trim($data['value']);
				
				if(!empty($value))
					switch($data["restriction"])
					{
						case 'starts_with': $result = wpjce_starts_with($url, $value); break;
						case 'ends_with': $result = wpjce_ends_with($url, $value); break;
						case 'equal_to': $result = $url == $value; break;
						case 'not_equal_to': $result = $url != $value; break;
						case 'contains': $result = strpos($url, $value) !== false; break;
						case 'not_contains': $result = strpos($url, $value) === false; break;
					}
				if($result)
					return true;
			}
			else if(isset($post) && $post->ID != null)
			{
				switch($data["restriction"])
				{
					case 'belongs': $result = in_array($post->ID, $data['value']); break;
					case 'not_belongs': $result = !in_array($post->ID, $data['value']); break;
				}
				
				if($result)
					return true;
			}
		}
		
		return $result;
	}
	private function get_statuses_for_query()
	{
		return array('publish', 'draft');
	}
	public function get_code_data($post_id = false)
	{
		
		$result = array();
		if($post_id != false)
		{
			if(isset($this->cache_code_data[$post_id]))
				$result = $this->cache_code_data[$post_id];
			else
			{
				foreach($this->attributes as $attribute_name)
				{
					$result[$attribute_name] = $this->get_attribute($post_id, $attribute_name);
					$result[$attribute_name] = wpjce_get_value_if_set($result, $attribute_name, false) == false ? "" : $result[$attribute_name];
				}
				$this->cache_code_data[$post_id] = $result;
			}
		}
		else //never happens
		{
			if(isset($this->cache_code_data["global"]))
				$result = $this->cache_code_data[$post_id];
			else
			{
				foreach($this->attributes as $attribute_name)
					$result[$attribute_name] = "";
					
				$this->cache_code_data["global"] = $result;
			}
		}
		
		return $result;
	}
	public function remove_all_attributes($post_id)
	{
		foreach($this->attributes as $attribute_name)
			$this->remove_attribute($post_id, $attribute_name);
	}
	public function remove_attribute($post_id, $name)
	{
		 delete_post_meta( $post_id, $name);
	}
	public function update_attribute($post_id, $name, $value, $unique  = true)
	{
		update_post_meta($post_id, $name, $value, $unique);
	}
	public function get_attribute($post_id, $name, $single  = true)
	{
		return get_post_meta($post_id, $name, $single );
	}
}
?>