jQuery(document).ready(function()
{
	wpjce_init_post_ajax_loader();
});
function wpjce_init_post_ajax_loader()
{
	jQuery('.wpjce-post-selector-ajax').each(function(index, elem)
	{
		if(jQuery(elem).attr('already_init'))
			return true;
		
		jQuery(elem).select2(
			{
				width:'60%',
				ajax: {
				url: ajaxurl,
				dataType: 'json',
				delay: 250,
				multiple: true,
				data: function (params) {
				  return {
					search: params.term, // search term
					page: params.page,
					post_type: jQuery(elem).data('type'),
					action: 'wpjce_load_posts'
				  };
				},
				processResults: function (data, page) 
				{
			   
				   return {
					results: jQuery.map(data.results, function(obj) 
					 {
						//console.log(obj);
						return { id: obj.id, 
								 text: "ID: "+obj.id+" - "+obj.post_title };
					 }),
					pagination: {
								  'more': typeof data.pagination === 'undefined' ? false : data.pagination.more
								}
					
					};
				},
				cache: true
			  },
			  escapeMarkup: function (markup) { return markup; }, // let our custom formatter work
			  minimumInputLength: 0,
			  templateResult: wpjce_formatRepo, 
			  templateSelection: wpjce_formatRepoSelection  
			});
			
			jQuery(elem).data('already_init', true);
	});
}
function wpjce_formatRepo (repo) 
{
	if (repo.loading) return repo.text;
	
	var markup = '<div class="clearfix">' +
			'<div class="col-sm-12">' + repo.text + '</div>';
    markup += '</div>'; 
	
    return markup;
}

function wpjce_formatRepoSelection (repo) 
{
  return repo.full_name || repo.text;
}