<?php
/*
Plugin Name: Custom JavaScript & CSS in Pages!
Description: JavaScript & CSS code globally or in single pages, posts or custom posts!
Author: Lagudi Domenico
Version: 3.1
*/


define('WPJCE_PLUGIN_PATH', rtrim(plugin_dir_url(__FILE__), "/") );
define('WPJCE_PLUGIN_ABS_PATH', plugin_dir_path( __FILE__ ) );
define('WPJCE_PLUGIN_LANG_PATH', basename( dirname( __FILE__ ) ) . '/languages' ) ;

/* if ( in_array( 'woocommerce/woocommerce.php', apply_filters( 'active_plugins', get_option( 'active_plugins' ) ) ) ||
     (is_multisite() && array_key_exists( 'woocommerce/woocommerce.php', get_site_option('active_sitewide_plugins') ))
	) */
{
	//com
	//include_once( "classes/com/WPJCE_Acf.php");
	include_once( "classes/com/WPJCE_Global.php");
	
	if(!class_exists('WPJCE_Code'))
	{	
		require_once('classes/com/WPJCE_Code.php');
		$wpjce_code_model = new WPJCE_Code();
	} 
	if(!class_exists('WPJCE_User'))
	{	
		require_once('classes/com/WPJCE_User.php');
		$wpjce_user_model = new WPJCE_User();
	} 
	if(!class_exists('WPJCE_Html'))
	{	
		require_once('classes/com/WPJCE_Html.php');
		$wpjce_html_helper = new WPJCE_Html();
	} 
	if(!class_exists('WPJCE_Post'))
	{	
		require_once('classes/com/WPJCE_Post.php');
		$wpjce_post_model = new WPJCE_Post();
	}
	if(!class_exists('WPJCE_Wpml.php'))
	{	
		require_once('classes/com/WPJCE_Wpml.php');
		$wpjce_wpml_helper = new WPJCE_Wpml();
	} 

	//admin
	//moved inside the wpjce_admin_init() function

	//frontend
	//to move inside the wpjce_frontend_init() function ??
	if(!class_exists('WPJCE_FilterManager.php'))
	{	
		require_once('classes/frontend/WPJCE_FilterManager.php');
		$wpjce_frontend_helper = new WPJCE_FilterManager();
	} 
	
	//add_action( 'wp_loaded', 'wpjce_frontend_init');
	add_action('admin_menu', 'wpjce_init_admin_panel');
	add_action('admin_init', 'wpjce_admin_init');
	add_action('init', 'wpjce_init');

}
function wpjce_admin_init()
{
	if(!class_exists('WPJCE_CodePage'))
	{	
		require_once('classes/admin/WPJCE_CodePage.php');
		$wpjce_code_page = new WPJCE_CodePage();
	}
	if(!class_exists('WPJCE_PostPage'))
	{	
		require_once('classes/admin/WPJCE_PostPage.php');
		$wpjce_post_page = new WPJCE_PostPage();
	}
}
function wpjce_frontend_init() 
{
	if ( !is_admin() ) 
	{ 
		
	}
}

function wpjce_init()
{
	load_plugin_textdomain('wp-js-css-everywhere', false, basename( dirname( __FILE__ ) ) . '/languages' );
}
function wpjce_get_free_menu_position($start, $increment = 0.1)
{
	foreach ($GLOBALS['menu'] as $key => $menu) {
		$menus_positions[] = $key;
	}

	if (!in_array($start, $menus_positions)) return $start;

	/* the position is already reserved find the closet one */
	while (in_array($start, $menus_positions))
	{
		$start += $increment;
	}
	return $start;
}
function wpjce_init_admin_panel()
{
	/* if(!current_user_can('edit_posts'))
		return; */
	/* $user = wp_get_current_user();
	
	$allowed_roles = array('manage_woocommerce', 'administrator');
	if( !array_intersect($allowed_roles, $user->roles )
		return; 
	
	$place = wpjce_get_free_menu_position(54, 0.5); */

	//add_menu_page( __( 'Shipping tracking', 'woocommerce' ), __( 'Shipping tracking', 'woocommerce' ), 'edit_posts', 'wcst-shipping-tracking', null, WPJCE_PLUGIN_PATH."/img/menu-icon.png", (string)$place );
	//remove_submenu_page( 'wcst-shipping-tracking', 'wcst-shipping-tracking');
}

function wpjce_var_dump($var)
{
	echo "<pre>";
	var_dump($var);
	echo "</pre>";
}
?>